
if ( !( "FlashBangCrumpkin" in getroottable() ) ) {
	printl("----------------------------------------------------")
	printl("FlashBangCrumpkin Script Pre-Loaded")
	printl("----------------------------------------------------")
}

IncludeScript("sprinklesscripts/lib/sprinkles_util.nut")

::pumpkinindex <- PrecacheModel("models/props_halloween/pumpkin_loot.mdl")
::pumpkinflashbangindex <- PrecacheModel("models/props_halloween/pumpkin_loot_flashbang.mdl")

function Precache() {
    self.PrecacheSoundScript("flashbang/flashbang_explode1.wav")
    self.PrecacheSoundScript("flashbang/flashbang_explode2.wav")
}

::PickupFlashBang <- function () {

    local player = self

    if (player != null)
    {
        EmitSoundEx({
            sound_name = "flashbang/flashbang_explode2.wav",
            origin = self.GetCenter(),
            pitch = RandomInt(94, 110),
            volume = RandomFloat(0.8, 1),
            sound_level = 155,
            entity = self,
        });
        RadiusFlash ( self.GetOrigin(), self, self, 3.55, 0, DMG_BLAST, 0, 0 );

        player.AddCondEx(TF_COND_CRITBOOSTED_PUMPKIN, 6, player)
    }
}

local EventsID = UniqueString()
getroottable()[EventsID] <-
{
    ////////// Add your events here
    // Example: "post_inventory_application" is sent when a player gets a whole new set of items, aka touches a resupply locker / respawn cabinet or spawns in.
	OnGameEvent_player_death = function(params)
	{
        for (local entity; entity = Entities.FindByClassname(entity, "tf_ammo_pack");)
        {
            if (NetProps.GetPropInt(entity, "m_nModelIndex") == pumpkinindex)
            {
                if (RandomInt(0, 1) == 1)
                {
                    local healthKit = SpawnEntityFromTable("item_armor", {
                        "OnPlayerTouch": "!self,Kill,,-1,-1",
                        "OnPlayerTouch": "!activator,CallScriptFunction,PickupFlashBang,-1,-1",
                      });
                    healthKit.SetMoveType(5, 1);
                    healthKit.SetAbsOrigin(entity.GetOrigin());
                    entity.Destroy()
                    healthKit.SetAbsVelocity(Vector(RandomFloat(-125, 125), RandomFloat(-125, 125), 300));
                    healthKit.SetModel("models/props_halloween/pumpkin_loot_flashbang.mdl")
                    EntFireByHandle(healthKit, "Kill", "", 20, null, null);

                    //NetProps.SetPropInt(entity, "m_nModelIndex", pumpkinflashbangindex )
                    break;
                }
            }
        }
	}

    OnGameEvent_player_spawn = function(params)
    {
        local player = GetPlayerFromUserID(params.userid)
        NetProps.SetPropInt(player, "m_ArmorValue", 0x80000000)
    }

    OnGameEvent_post_inventory_application = function(params)
	{
        local player = GetPlayerFromUserID(params.userid)
        NetProps.SetPropInt(player, "m_ArmorValue", 0x80000000)
	}

    // Cleanup events on round restart
    OnGameEvent_scorestats_accumulated_update = function(_) { delete getroottable()[EventsID] }
} __CollectGameEventCallbacks(getroottable()[EventsID])

if ( !( "FlashBangCrumpkin" in getroottable() ) ) {
	::FlashBangCrumpkin <- {}
	printl("----------------------------------------------------")
	printl("FlashBangCrumpkin Script Fully-Loaded")
	printl("----------------------------------------------------")
}